#!/usr/bin/python3

#	cve-manager : CVE management tool
#	Copyright (C) 2017-2022 Alexey Appolonov
#
#	This program is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program.  If not, see <http://www.gnu.org/licenses/>.

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

import os
from ax.sefunctions import DateTimeNow

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

class FWriter():

	def __init__(self, dir_path):

		self.dir = dir_path

	# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	# Write given text into file with generated name inside self.dir

	def Execute(self, file_name_prefix, txt, type_of_issues=None, branch=None,
			distro=None):

		if not self.dir:
			return f'The "out_dir" parameter is not assigned'

		if not os.path.isdir(self.dir):
			return f'There is no {self.dir} dir'

		if not os.access(self.dir, os.W_OK):
			return f'Cant\'t write to {self.dir} dir'

		file_name = file_name_prefix
		if type_of_issues:
			file_name += f'_{type_of_issues}'
		if branch:
			file_name += f'_{branch}'
			if distro:
				file_name += f':{distro}'
		file_name += f'_{DateTimeNow()}'

		file_path = os.path.join(self.dir, file_name)

		try:
			with open(file_path, 'w') as f:
				f.write(txt)
		except:
			err = f'Can\'t write to {file_path} file'

		return ''
